/**
 * @author  Dacian Todea.
 * @email   electrodacus@gmail.com
 * @website http://electrodacus.com
 * @link    http://electrodacus.com/SBMS100/SW/SBMS_ILI9341.zip
 * @version v0.7
 * @license GNU GPL v3
 * @brief This is a small demo for the ILI9341 graphic library

 -----------------------------------------------------------------------

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------
*/


#include "defines.h"
#include "SBMS_ili9341.h"
#include "tm_stm32f4_fonts.h"
#include <stdio.h>


unsigned int j;
unsigned int jj,jjj;

void clock_init(void);


#define delay()						\
do {							\
  register unsigned int i;				\
  for (i = 0; i < 20000000; ++i)				\
    __asm__ __volatile__ ("nop\n\t":::"memory");	\
} while (0)

int main(void)
{
	clock_init();


	TM_ILI9341_Init();
	TM_ILI9341_Rotate(TM_ILI9341_Orientation_Landscape_1);
	while(1)
	{

		Fill2(0x9800);

		Puts(10, 10, "50x Fill (swipe)", &TM_Font_16x26, 0xFFFF, 0x9800);

		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "Fill time = 150ms", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "512Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);

		delay();


		for (j = 0; j < 10; ++j)
		{
			Fill(0xFFFF);
			Fill(0xF800);
			Fill(0x07E0);
			Fill(0x001F);
			Fill(0x0);
		}

		Fill2(0x9800);

		Puts(10, 10, "50x Fill2 (blend)", &TM_Font_16x26, 0xFFFF, 0x9800);


		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "Fill time = 160ms", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "480Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);
		delay();

		for (j = 0; j < 10; ++j)
				{
					Fill2(0xFFFF);
					Fill2(0xF800);
					Fill2(0x07E0);
					Fill2(0x001F);
					Fill2(0x0);
				}


		Fill2(0x9800);

		Puts(10, 10, "500x FillRectangle", &TM_Font_16x26, 0xFFFF, 0x9800);

		DrawFilledRectangle(240, 40, 304,88,0x07E0);

		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "8.4ms 64x48px", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "457Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);

		delay();
		Fill2(0x00);

		for (jj=0; jj<20; ++jj)
						{
				for (j = 0; j < 25; ++j)
						{
					     DrawFilledRectangle(0+(j*12), 0+(jj*12), 64+(j*12), 48+(jj*12), (((jj+1)*(j+1))*(65000/(j+jj+2))));
						}

						}

		Fill2(0x9800);

		Puts(10, 10, "500x FillCircle", &TM_Font_16x26, 0xFFFF, 0x9800);


		DrawFilledCircle(271, 71, 31,0x07E0);


		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "12ms 31px diameter", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "320Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);
		delay();

		Fill2(0x00);

		for (jj=0; jj<20; ++jj)
								{
						for (j = 0; j < 25; ++j)
								{
							DrawFilledCircle(31+(j*12),31+(jj*12),31,(((jj+1)*(j+1))*(65000/(j+jj+2))));
								}

								}
		Fill2(0x9800);

		Puts(10, 10, "21k 11x18 & 10k mix", &TM_Font_16x26, 0xFFFF, 0x9800);


		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "0.8ms / 11x18 char", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "241Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);

		delay();

		Fill2(0x00);
				DrawVline(0,319,0,0xFBE7);
				DrawVline(0,319,20,0xFBE7);
				DrawVline(0,319,195,0xFBE7);
				DrawVline(0,319,194,0xFBE3);
				DrawVline(0,319,193,0xFBE7);
				DrawVline(0,319,192,0xFB83);


				for (j = 2; j < 8; ++j)
				{
						Puts(11, (j*24)-23, "Electrodacus-SBMS100-ILI9341", &TM_Font_11x18, 0xFBE7, ILI9341_COLOR_BLACK);
						Putc(0,(j*24)-23, (48+j)-1, &TM_Font_11x18, 0x7900, 0x0);
				}

		for	(jj = 1; jj < 50; ++jj){

		  Puts(0, 2, "         Electrodacus        ", &TM_Font_11x18, 0x00, (jj*1280));


		for (j = 1; j < 8; ++j)
				{
		if (j!=1){
		Puts(11, (j*24)-23, "Electrodacus-SBMS100-ILI9341", &TM_Font_11x18, 0xFBE7, ILI9341_COLOR_BLACK);
		Putc(0,(j*24)-23, (48+j)-1, &TM_Font_11x18, 0x7900, 0x0);
		}
		Puts(11, j*24+1, "Electrodacus-SBMS100-ILI9341", &TM_Font_11x18, 0x00, 0xFBE7);
		Putc(0,(j*24)+1, 48+j, &TM_Font_11x18, 0x8000, 0xFE00);
		if (j>=2){

		}
		if (j==1)
		{
		Puts(11, (8*24)-23, "Electrodacus-SBMS100-ILI9341", &TM_Font_11x18, 0xFBE7, ILI9341_COLOR_BLACK);
		Putc(0,(8*24)-23, 48+8-1, &TM_Font_11x18, 0x7900, 0x0);

		}

				}
		}

		for (jjj = 1; jjj < 11; ++jjj)
		{
		for (jj = 1; jj < 11; ++jj)
		{
		for (j = 1; j < 11; ++j)
		{
		Putc(190,216 , 47+jjj, &TM_Font_7x10, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Puts(197, 216, ".", &TM_Font_7x10, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(204, 216, 47+jj, &TM_Font_7x10, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(211, 216, 47+j, &TM_Font_7x10, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);

		Putc(4, 200, 47+jjj, &TM_Font_16x26, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(20, 200, 47+jj, &TM_Font_16x26, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(36, 200, 47+j, &TM_Font_16x26, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);

		Putc(90, 208, 47+jjj, &TM_Font_11x18, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(101, 208, 47+jj, &TM_Font_11x18, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		Putc(112, 208, 47+j, &TM_Font_11x18, ILI9341_COLOR_WHITE, ILI9341_COLOR_BLACK);
		DrawVline(0,(j+(jj*10)+(jjj*100))/3.5,235,0xFFFF);
		}
		}
		}

		Fill2(0x9800);

		Puts(10, 10, "16k V & 12k H line", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "0.6ms/line", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "460Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);

		delay();

		for (jj=0; jj<50; ++jj)
												{
										for (j = 0; j < 320; ++j)
												{
											DrawHline(0,240,j,(((jj+1)*(j+1))*(64000/(j+jj+1))));

												}
										for (j = 0; j < 240; ++j)
												{
											DrawVline(0,320,j,(((jj+1)*(j+1))*(60000/(j+jj+2))));
												}

												}

		Fill2(0x9800);

		Puts(10, 10, "6k Rectangle", &TM_Font_16x26, 0xFFFF, 0x9800);

		DrawRectangle(240, 40, 304,88,0x07E0);

		Puts(10, 86, "CPU 40Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 122, "SPI 20Mhz", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 158, "1.46ms/rectangle", &TM_Font_16x26, 0xFFFF, 0x9800);
		Puts(10, 194, "460Kpixels/second", &TM_Font_16x26, 0xFFFF, 0x9800);

		delay();



			DrawRectangle(0+jj,0+jj,319-jj,239-jj, 0x0000);


		for	(jjj = 0; jjj < 25; ++jjj){


		for	(j = 0; j < 120; ++j){
		DrawRectangle(119-j,119-j,200+j,120+j, (jjj+9)*1999);
				}

		for	(jj = 0; jj < 120; ++jj){
		DrawRectangle(0+jj,0+jj,319-jj,239-jj, (jjj+1)*2080);
		}


		}

	}
}

void clock_init(){
   /* Start with HSI clock (internal 8mhz), divide by 2 and multiply by 9 to
   * get maximum allowed frequency: 36Mhz
   * Enable PLL, wait till it's stable, then select it as system clock*/
  RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_10);
  RCC_PLLCmd(ENABLE);
  while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET) {}
  RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

  /* Set HCLK, PCLK1, and PCLK2 to SCLK (these are default */
  RCC_HCLKConfig(RCC_SYSCLK_Div1);
  RCC_PCLK1Config(RCC_HCLK_Div1);
  RCC_PCLK2Config(RCC_HCLK_Div1);


}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
